    // Maintain a day's worth of hourly temperature readings.
class DayTemperatures {
    public static final int HoursPerDay = 24;

        // Return the temperature for the given hour.
        // Return -1 if the hour is invalid.
    public int getTemperature(int hour){
        if(validHour(hour)){
            return getTemperatures()[hour];
        }
        else{
            return -1;
        }
    }

        // Set the given temperature for the given hour.
        // Do nothing if the hour is invalid.
    public void setTemperature(int hour,int temp){
        if(validHour(hour)){
            getTemperatures()[hour] = temp;
        }
    }

        // Return an array containing the hours with the
        // highest temperature values.
    public int[] hottestHours(){
        int[] temps = getTemperatures();
        // Find the hottest, and how many occurrences.
        int hottest = temps[0];
        int count = 1;

        for(int hour = 1; hour < HoursPerDay; hour++){
            if(temps[hour] > hottest){
                hottest = temps[hour];
                count = 1;
            }
            else if(temps[hour] == hottest){
                count++;
            }
            // else - cooler
        }
        // Create the array to contain the indices.
        int[] indices = new int[count];
        // Where to store the next index.
        int nextIndex = 0;
        // Store the indices matching hottest temperature.
        for(int hour = 0; hour < HoursPerDay; hour++){
            if(temps[hour] == hottest){
                indices[nextIndex] = hour;
                nextIndex++;
            }
        }
        return indices;
    }

        // Return the mean daily temperature.
    public double meanTemperature(){
        int[] temps = getTemperatures();
        double sum = 0;
        for(int hour = 0; hour < HoursPerDay; hour++){
            sum += temps[hour];
        }
        return sum/HoursPerDay;
    }

    private boolean validHour(int hour){
        return (hour >= 0) && (hour < HoursPerDay);
    }

    private int[] getTemperatures(){
        return temperatures;
    }

    private final int[] temperatures = new int[HoursPerDay];
}
