    // Store a week's worth of DayTemperatures.
class WeeklyTemperatures {
    public static final int DaysPerWeek = 7;
    public static final int Sun = 0, Mon = 1, Tue = 2, Wed = 3,
                            Thu = 4, Fri = 5, Sat = 6;

    public WeeklyTemperatures(DayTemperatures[] temps){
        if((temps != null) && (temps.length == DaysPerWeek)){
            // Copy the object references from temps to the
            // days attribute.
            DayTemperatures[] days = getDays();
            System.arraycopy(temps,0,days,0,DaysPerWeek);
        }
    }

        // Return the DayTemperatures object for the given day.
        // Return null if the day is not valid.
    public DayTemperatures getDay(int day){
        if(validDay(day)){
            return getDays()[day];
        }
        else{
            return null;
        }
    }

        // Return the mean of the individual daily temperatures.
    public double meanDailyTemperature(){
        double sum = 0;
        DayTemperatures[] days = getDays();
        for(int day = 0; day < DaysPerWeek; day++){
            sum += days[day].meanTemperature();
        }
        return sum/DaysPerWeek;
    }

    private boolean validDay(int day){
        return (day >= Sun) && (day <= Sat);
    }

    private DayTemperatures[] getDays(){
        return days;
    }

    private final DayTemperatures[] days =
                new DayTemperatures[DaysPerWeek];
}
