import java.io.*;

        // Write primitive values and strings to a DataOutputStream.
        // Prefix each with a byte indicating the type of data
        // written.
        // This version writes only boolean, int, double and String
        // as a sample.
class DataEncoder {
    public static final byte BOOLEAN = 0, INT = 1, DOUBLE = 2,
                             STRING = 3,
                             ENDOFFILE = 127;

    public DataEncoder(DataOutputStream stream){
        this.stream = stream;
    }

    public void encodeBoolean(boolean b) throws IOException {
        DataOutputStream stream = getStream();
        stream.writeByte(BOOLEAN);
        stream.writeBoolean(b);
    }

    public void encodeDouble(double d) throws IOException {
        DataOutputStream stream = getStream();
        stream.writeByte(DOUBLE);
        stream.writeDouble(d);
    }

    public void encodeInt(int i) throws IOException {
        DataOutputStream stream = getStream();
        stream.writeByte(INT);
        stream.writeInt(i);
    }

    public void encodeString(String s) throws IOException {
        DataOutputStream stream = getStream();
        stream.writeByte(STRING);
        stream.writeUTF(s);
    }

    public void encodeEndOfFile() throws IOException {
        DataOutputStream stream = getStream();
        stream.writeByte(ENDOFFILE);
        stream.flush();
    }

    private DataOutputStream getStream(){
        return stream;
    }

    private final DataOutputStream stream;
}
