class Radio {
    // Radios cannot be set below this frequency.
    public static final double MIN_FREQUENCY = 80000000.0;
    // Step up or down by the following amount.
    public static final double INCREMENT = 0.1;

    public void up(){
        try{
            setFrequency(getFrequency()+INCREMENT);
        }
        catch(RuntimeException e){
            // This should never happen. Restore it to a legitimate
            // value.
            setFrequency(MIN_FREQUENCY);
        }
    }

    public void down(){
        try{
            setFrequency(getFrequency()-INCREMENT);
        }
        catch(RuntimeException e){
            // We have hit the minimum. Take no further action.
        }
    }

    public double getFrequency(){
        return frequency;
    }

        // f must be at least MIN_FREQUENCY.
    public void setFrequency(double f) throws RuntimeException {
        if(f < MIN_FREQUENCY){
            throw new RuntimeException("Frequency: "+f+
                                       " is below the minimum of "+MIN_FREQUENCY);
        }
        frequency = f;
    }
        
    private double frequency = MIN_FREQUENCY;
}
