import java.util.Random;

    // Return an increasing sequence of random numbers, starting at zero.
class RandomNumbers implements NumberGenerator2 {
    // The maximum step between successive numbers.
    public static final int MAX_STEP = 20;

    public int nextNumber(){
        int result = getNext();
        // Generate an offset for the next number.
        setNext(result+1+getRand().nextInt(MAX_STEP));
        return result;
    }

        // Return the next number in the sequence that is divisible
        // by divisor.
    public int nextDivisibleBy(int divisor){
        int result;
        do{
            result = nextNumber();
        } while((result % divisor) != 0);
        return result;
    }

    private int getNext(){
        return next;
    }

    private void setNext(int n){
        next = n;
    }

    private Random getRand(){
        return rand;
    }

    private int next = 0;
    private final Random rand = new Random();
}
