import java.util.*;

    // Maintain a collection of SuitedCard objects for a player.
    // The cards in a hand may be sorted.
class Hand {
    public void add(SuitedCard c){
        if(c != null){
             getCards().add(c);
        }
    }

        // Return all cards with matching suit, if any.
        // Return a zero-length array if there are none.
    public SuitedCard[] getCardsInSuit(String suit){
        // Temporary storage for the matching cards.
        LinkedList matchingCards = new LinkedList();
        Iterator cards = getCards().iterator();
        while(cards.hasNext()){
            SuitedCard c = (SuitedCard) cards.next();
            if(c.getSuit().equals(suit)){
                matchingCards.add(c);
            }
        }
        SuitedCard[] cardArray = new SuitedCard[matchingCards.size()];
        matchingCards.toArray(cardArray);
        return cardArray;
    }

        // Remove the chosen card from the collection.
    public void remove(SuitedCard c){
        getCards().remove(c);
    }

    public int numCards(){
        return getCards().size();
    }

    public void sort(){
        Collections.sort(getCards());
    }

    private LinkedList getCards(){
        return cards;
    }

    // Store the cards in a linked list, because we only need
    // access at either end.
    private final LinkedList cards = new LinkedList();
}
