import java.util.Iterator;

        // Generate an infinite sequence of numbers.
class AnonymousMain {
    public static void main(String[] args){
        Iterator i = steps(3);
        while(i.hasNext()){
            System.out.println(i.next()+" ");
        }
    }

        // Return an anonymous implementation of Iterator
        // that returns an infinite sequence
        //     0, 0+stepSize, 0+2*stepSize, ...
    public static Iterator steps(final int stepSize){
        return new Iterator(){
            public boolean hasNext(){
                return true;
            }

            public void remove() throws UnsupportedOperationException {
                throw new UnsupportedOperationException("remove");
            }

            public Object next(){
                int nextValue = getNext();
                setNext(nextValue+stepSize);
                return new Integer(nextValue);
            }

            private int getNext(){
                return next;
            }

            private void setNext(int n){
                next = n;
            }

            private int next = 0;
        };
    }
}
