    // A class designed to hold the population size of a town.
    // Provide a method to allow the population size to be altered
    // by small amounts.
class Population2 {
    public Population2(String name,int count){
        this.count = count;
        this.name = name;
    }

        // Change the population by amount, which may be positive
        // or negative.
    public void populationChange(int amount){
        setCount(getCount()+amount);
    }

    public int getCount(){
        return count;
    }

        // Set the population count to c.
        // Avoid changes which are too great.
    public void setCount(int c){
        // Define the maximum change in either direction.
        final int maxChange = 12;
        int change = count-c;
        if(change < 0){
            change = -change;
        }
        if(change <= maxChange){
            count = c;
        }
        else{
            System.out.println("Attempt to change the population of "+
                               getName()+" by more than "+maxChange);
        }
    }

    public String getName(){
        return name;
    }

        // Return a descriptive string.
    public String toString(){
        return getName()+". Population "+getCount();
    }

    // The attribute used to record the current size of the population.
    private int count = 0;
    // The name of the town.
    private final String name;
}
